--[[
          Toxynas 'I interuppt that'
          Version 0.0.9 (based on Elphies Version 3.3.9)
--]]

local TIIT_color   = '|cffafdfd0';                     -- addon-color for the mesages
local TIIT_name    = "Toxyna's 'I Interrupted That'"   -- addon titel used for messages
local TIIT_version = '0.0.9'                           -- version of the addon
local TIIT_date    = '2012/09/26'                      -- version of the addon

ToxynasIInterruptedThatDB = {
    isActive                    = 1,                                                -- addon is active
    interruptOutput             = 'Emote',                                          -- addon's output channel is emote
    message                     = 'PERSON unterbricht den Zauber SPELL von MOB!',   -- message for other channels than emote
    announceInterruptsFromAll   = 0,                                                -- announce interrupts from all party members
    language                    = 'de',                                             -- language for further versions
}

print(TIIT_color .. "" .. TIIT_name .. " -- /tiit for more.|r");

local ToxynasIInterruptedThat = CreateFrame("Frame");

local function OnEvent(self, event, ...)
    local dispatch = self[event];

    if dispatch then
        dispatch(self, ...);
    end
end

ToxynasIInterruptedThat:SetScript("OnEvent", OnEvent);
ToxynasIInterruptedThat:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
ToxynasIInterruptedThat:RegisterEvent("ADDON_LOADED");

-- Falls noch keine Werte bei einem vorigen Benutzen hinterlegt wurden,
-- werden hier beim Laden des Addons (einloggen, reload) Default-Werte
-- eingestellt:
function ToxynasIInterruptedThat:ADDON_LOADED(...)
    if not ToxynasIInterruptedThatDB.isActive then
        ToxynasIInterruptedThatDB.isActive = 1;
    end
    if not ToxynasIInterruptedThatDB.interruptOutput then
        ToxynasIInterruptedThatDB.interruptOutput = 'Emote';
    end
    if not ToxynasIInterruptedThatDB.message then
        ToxynasIInterruptedThatDB.message = "PERSON unterbricht den Zauber SPELL von MOB!";
    end
    if not ToxynasIInterruptedThatDB.announceInterruptsFromAll then
        ToxynasIInterruptedThatDB.announceInterruptsFromAll = 0;
    end
    -- print(TIIT_color .. "" .. TIIT_name .. "variables were loaded.|r");
    self:UnregisterEvent("ADDON_LOADED");
    -- print(TIIT_color .. "" .. TIIT_name .. "event was unregistered.|r");
end

function ToxynasIInterruptedThat:COMBAT_LOG_EVENT_UNFILTERED(...)
    --
    -- if the addon is not active : return
    --
    if ToxynasIInterruptedThatDB.isActive == 0 then
        return;
    end

    --
    -- get some of the event parameters:
    --
    local eventType        = select(2, ...);
    local interruptingUser = select(5, ...);
    local interruptedUser  = select(9, ...);
    local spellID          = select(15, ...);
    local interruptedSpell = GetSpellLink(spellID);
    --
    -- handel the event SPELL_INTERRUPT:
    --
    if eventType == "SPELL_INTERRUPT" then
        --
        -- if someone else interrupts and we don't want to tell: return
        --
        if ToxynasIInterruptedThatDB.announceInterruptsFromAll == 0 and
            interruptingUser ~= UnitName("player") then
                return;
        end

        --
        -- if the interrupter is not in our party/raid: return
        --
        if UnitInRaid("player")  and not UnitInRaid(interruptingUser)  or
           UnitInParty("player") and not UnitInParty(interruptingUser) then
            return;
        end

        --
        -- handle the 'Emote' mode:
        --
        if ToxynasIInterruptedThatDB.interruptOutput == 'Emote' then
            -- the player has interrupted:
            if interruptingUser == UnitName("player") then
                local localizedClass, englishClass = UnitClass("player");
                local messageToSend;
                if "SHAMAN" == englishClass then
                    messageToSend = "schickt einen Windstoß gen " .. interruptedUser
                            .. " und unterbricht " .. interruptedSpell .. ".";
                elseif "ROGUE" == englishClass then
                    -- Rogues can also interrupt via Gauge, Solar Plexus,
                    -- Cheap Shot, or Garotte, but only Kick is a
                    -- "SPELL_INTERRUPT" and I yet have no idea, how to get
                    -- the other four abilities.
                    messageToSend = "tritt " .. interruptedUser .. " und unterbricht "
                            .. interruptedSpell .. ".";
                elseif "MAGE" == englishClass then
                    messageToSend = "spricht einen Zauber, der " .. interruptedUser ..
                            " beim Wirken von " .. interruptedSpell .. ".";
                elseif "WARRIOR" == englishClass then
                    -- Warriors can interrupt spells via "Zuschlagen"
                    -- (Spell id 6552) and "Unterbrechender Ruf" (Spell id 102060),
                    -- so I provide two different emotes for them:
                    local interruptSpellId = select(12, ...);
                    if interruptSpellId == 6552 then -- Zuschlagen
                        messageToSend = "schlägt mit der gepanzerten Faust " ..
                                "dazwischen und hindert " .. interruptedUser ..
                                " am Wirken von " .. interruptedSpell .. ".";
                    elseif interruptSpellId == 102060 then -- Unterbrechender Ruf
                        messageToSend = "ruft laut und hindert " .. interruptedUser ..
                                " am Wirken von " .. interruptedSpell .. ".";
                    else
                        messageToSend = "unterbricht " .. interruptedUser ..
                                " beim Wirken von " .. interruptedSpell .. ".";
                    end
                else
                    messageToSend = "unterbricht " .. interruptedUser ..
                            " beim Wirken von " .. interruptedSpell .. ".";
                end
                SendChatMessage(messageToSend, "EMOTE");

            -- someone else has interrupted:
            else
                SendChatMessage(
                        "bewundert, wie " .. interruptingUser .. " " .. interruptedUser
                        .. " daran hindert. " .. interruptedSpell
                        .. " zu zaubern.",
                        "EMOTE")
            end
        --
        -- other channel than 'Emote':
        --
        else
            local numberOfGroupMembers = GetNumGroupMembers();
            local inParty = numberOfGroupMembers > 0 and numberOfGroupMembers <= 5;
            local inRaid = numberOfGroupMembers > 5;

            --
            -- determine the channel for the mode 'Auto':
            --
            local autoChannel = "Self";
            if inParty then
                autoChannel = "PARTY";
            elseif inRaid then
                local ssInInstance, ssinstanceType = IsInInstance();
                -- http://www.wowwiki.com/API_IsInInstance
                -- results: none, pvp, arena, party, raid
                if ssinstanceType == "pvp" then
                    autoChannel = "BATTLEGROUND";
                else
                    autoChannel = "RAID"
                end
            end

            --
            -- determine output string
            --
            local interruptMessage = ToxynasIInterruptedThatDB.message;
            interruptMessage = string.gsub(
                    ToxynasIInterruptedThatDB.message, "(MOB)", interruptedUser);
            interruptMessage = string.gsub(
                    interruptMessage, "(SPELL)", GetSpellLink(spellID));
            if interruptingUser ~= UnitName("player") then
                interruptMessage = string.gsub(
                        interruptMessage, "(PERSON)", interruptingUser);
            else
                interruptMessage = string.gsub(
                        interruptMessage, "(PERSON)", UnitName("player"));
            end

            --
            -- Ausgabe der Nachricht abhängig von der gewählten Ausgabeform
            --
            if ToxynasIInterruptedThatDB.interruptOutput == 'Self'
                    or autoChannel == 'Self' then
                print(interruptMessage);
            elseif ToxynasIInterruptedThatDB.interruptOutput == 'Say' then
                if autoChannel == "pvp" then
                    print(interruptMessage);
                else
                    SendChatMessage(interruptMessage, "SAY");
                end
            elseif ToxynasIInterruptedThatDB.interruptOutput == 'Auto' then
                if (not inParty) and (not inRaid) then
                    print(interruptMessage);
                else
                    SendChatMessage(interruptMessage, autoChannel);
                end
            end
        end
    end
end

SLASH_TIIT1 = "/tiit"
SlashCmdList["TIIT"] =
function(msg)
    local a1 = gsub(msg, "%s*([^%s]+).*", "%1");       -- first parameter
    local a2 = gsub(msg, "%s*([^%s]+)%s*(.*)", "%2");  -- second parameter
    a1 = string.lower(a1);                             -- to lower characters 'eMotE' -> 'emote'

    if a1 == "" or a1 == "help" then
        TIIT_help();
    elseif a1 == "info" then
        TIIT_show_info();
    elseif a1 == "toggle" then
        TIIT_toggle_addon_active();
    elseif a1 == "say" then
        ToxynasIInterruptedThatDB.interruptOutput = 'Say';
        TIIT_announce_output_channel();
    elseif a1 == "self" then
        ToxynasIInterruptedThatDB.interruptOutput = 'Self';
        TIIT_announce_output_channel();
    elseif a1 == "auto" then
        ToxynasIInterruptedThatDB.interruptOutput = 'Auto';
        TIIT_announce_output_channel();
    elseif a1 == "emote" then
        ToxynasIInterruptedThatDB.interruptOutput = 'Emote';
        TIIT_announce_output_channel();
    elseif (a1 == "allmembers") then
        TIIT_toggle_allmembers();
    elseif (a1 == "msg") then
        print(TIIT_color .. "message is: |r" .. ToxynasIInterruptedThatDB.message);
    elseif a1 == 'setmsg' then
        local has_mob    = nil ~= string.find(a2, "MOB",    1, true);
        local has_spell  = nil ~= string.find(a2, "SPELL",  1, true);
        local has_person = nil ~= string.find(a2, "PERSON", 1, true);
        if has_mob and has_spell and has_person then
            print(TIIT_color .. a2 .. " is valid |r");
            ToxynasIInterruptedThatDB.message = a2;
            print(TIIT_color .. "message is set to: |r"
                    .. ToxynasIInterruptedThatDB.message);
        else
            print(TIIT_color .. a2 .. " is NOT valid (use MOB for the enemy, "
                    .. "SPELL for the spell and PERSON for the interrupter "
                    .. "as placeholders)|r");
            print(TIIT_color .. "message stays: |r"
                    .. ToxynasIInterruptedThatDB.message);
        end
    else
        print(TIIT_color .. TIIT_name .. " parameter |r" .. a1 .. TIIT_color
                    .. " is unknown.|r");
    end
end

function TIIT_help()
    print(TIIT_color .. TIIT_name .. ' Version ' .. TIIT_version .. ' from '
            .. TIIT_date ..'|r');
    print(TIIT_color .. "To switch the interrupt message to a channel "
            .. "use /tiit with say, self, auto, or emote. Other commands are:|r");
    print(TIIT_color .. "/tiit or /tiit help - show this message|r");
    print(TIIT_color .. "/tiit info - show detailed informations|r");
    print(TIIT_color .. "/tiit toggle - swith " .. TIIT_name .. " on or off|r");
    print(TIIT_color .. "/tiit allmembers - switch interrupt reports from all "
            .. "members on or off|r");
    print(TIIT_color .. "/tiit msg - show the message (not used for the "
            .. "'Emote'-mode)|r");
    print(TIIT_color .. "/tiit setmsg - change the message. Use 'MOB' for the "
            .. "enemy's name, 'SPELL' for the enemy's spell you have "
            .. "interrupted, and 'PERSON' for the interrupting Person.|r");
end

function TIIT_show_info()
    print(TIIT_color .. "" .. TIIT_name .. " Informations:|r");
    if ToxynasIInterruptedThatDB.isActive ~= 1 then
        print(TIIT_color .. "" .. TIIT_name .. " is off.|r");
    else
        TIIT_announce_output_channel();
        local TIIT_allmembers = TIIT_color
                .. "Announce interrupts from all party members: |r";
        if ToxynasIInterruptedThatDB.announceInterruptsFromAll == 1 then
            print(TIIT_allmembers .. " On");
        else
            print(TIIT_allmembers .. " Off");
        end
        print(TIIT_color .. 'message for modes other than Emote is:|r' ..
                ToxynasIInterruptedThatDB.message);
    end
end

function TIIT_toggle_addon_active()
    if ToxynasIInterruptedThatDB.isActive == 1 then
        ToxynasIInterruptedThatDB.isActive = 0;
        print(TIIT_color .. "" .. TIIT_name .. " is now switched off.|r");
    else
        ToxynasIInterruptedThatDB.isActive = 1;
        print(TIIT_color .. "" .. TIIT_name .. " is now switched on.|r");
    end
end

function TIIT_announce_output_channel()
    print(TIIT_color .. "Output channel is: |r",
            ToxynasIInterruptedThatDB.interruptOutput);
end

function TIIT_toggle_allmembers()
    if ToxynasIInterruptedThatDB.announceInterruptsFromAll == 1 then
        ToxynasIInterruptedThatDB.announceInterruptsFromAll = 0
        print(TIIT_color .. "" .. TIIT_name
                .. " - Show interrupts from all members is switched off.|r");
    else
        ToxynasIInterruptedThatDB.announceInterruptsFromAll = 1
        print(TIIT_color .. "" .. TIIT_name
                .. " - Show interrupts from all members is switched on.|r");
    end
end
